aboutsummaryrefslogtreecommitdiff
path: root/v2/src/bin/mapentry
diff options
context:
space:
mode:
authorEuAndreh <eu@euandre.org>2023-04-10 19:20:55 -0300
committerEuAndreh <eu@euandre.org>2023-04-10 19:25:33 -0300
commit39eb7c48b9386a72fefc531ea58c5efef40505d2 (patch)
treeaa1cabde8226548c83eeaa06557a8a483a1c839a /v2/src/bin/mapentry
parentv2: src/bin/html: Remove empty lines from {pre,post}amble.html after processing (diff)
downloadeuandre.org-39eb7c48b9386a72fefc531ea58c5efef40505d2.tar.gz
euandre.org-39eb7c48b9386a72fefc531ea58c5efef40505d2.tar.xz
v2: Generate sitemap.xml
Diffstat (limited to 'v2/src/bin/mapentry')
-rwxr-xr-xv2/src/bin/mapentry75
1 files changed, 75 insertions, 0 deletions
diff --git a/v2/src/bin/mapentry b/v2/src/bin/mapentry
new file mode 100755
index 0000000..34b6e75
--- /dev/null
+++ b/v2/src/bin/mapentry
@@ -0,0 +1,75 @@
+#!/bin/sh
+set -eu
+
+usage() {
+ cat <<-'EOF'
+ Usage:
+ mapentry FILENAME
+ mapentry -h
+ EOF
+}
+
+help() {
+ cat <<-'EOF'
+
+
+ Options:
+ -h, --help show this message
+
+ FILENAME the name of the input .md file
+
+
+ Process FILENAME, and generate a "mapentry": an "<url>...</url>"
+ entry to be included into the final sitemap.xml
+
+
+ Examples:
+
+ Generate the sitemap entry entry for a TIL:
+
+ $ xmlentry src/til/a-til.md > src/til/a-til.mapentry
+ EOF
+}
+
+
+for flag in "$@"; do
+ case "$flag" in
+ --)
+ break
+ ;;
+ --help)
+ usage
+ help
+ exit
+ ;;
+ *)
+ ;;
+ esac
+done
+
+while getopts 'h' flag; do
+ case "$flag" in
+ h)
+ usage
+ help
+ exit
+ ;;
+ *)
+ usage >&2
+ exit 2
+ ;;
+ esac
+done
+shift $((OPTIND - 1))
+
+. src/lib.sh
+
+FILENAME="${1:-}"
+eval "$(assert_arg "$FILENAME" 'FILENAME')"
+
+
+url_absolute="$(url-for "$FILENAME" | absolute)"
+lastmod="$(git log -1 --format=%ad --date=short "$FILENAME")"
+export url_absolute lastmod
+
+envsubst < src/lib/mapentry.xml